﻿namespace DisplayRealTimeLog.ViewModel
{
  using System;
  using System.ComponentModel;
  using System.Linq.Expressions;
  using System.Runtime.CompilerServices;
  using System.Windows.Input;
  using System.Windows.Threading;

  using DisplayRealTimeLog.Annotations;

  public class DisplayRealTimeLogViewModel : INotifyPropertyChanged
  {
    public ICommand OnClickShowMessage {get; set;}
    public string DisplayCount { get; set; }

    public DisplayRealTimeLogViewModel()
    {
      OnClickShowMessage = new RelayCommand(ShowMessage);
    }

    private void ShowMessage(object obj)
    {
      for (int i = 0; i < 1000; i++)
      {
        Dispatcher.CurrentDispatcher.Invoke(DispatcherPriority.Background, new Action(
          () =>
            {
              DisplayCount = i.ToString();
              OnPropertyChanged(() => this.DisplayCount);
              System.Threading.Thread.Sleep(10);
            }));
      }
    }

    protected void OnPropertyChanged<T>(Expression<Func<T>> property)
    {
      if (this.PropertyChanged != null)
      {
        var mex = property.Body as MemberExpression;
        string name = mex.Member.Name;
        this.PropertyChanged(this, new PropertyChangedEventArgs(name));
      }
    }

    public event PropertyChangedEventHandler PropertyChanged;

    [NotifyPropertyChangedInvocator]
    protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
    {
      var handler = PropertyChanged;
      if (handler != null)
      {
        handler(this, new PropertyChangedEventArgs(propertyName));
      }
    }
  }
}